VERSION 5.00
Begin VB.Form frmComboTest 
   Caption         =   "Form1"
   ClientHeight    =   2760
   ClientLeft      =   1965
   ClientTop       =   2760
   ClientWidth     =   4350
   LinkTopic       =   "Form1"
   ScaleHeight     =   2760
   ScaleWidth      =   4350
   Begin VB.CommandButton cmdComboAPI 
      Caption         =   "Add items using Win32 API"
      Height          =   495
      Left            =   120
      TabIndex        =   2
      Top             =   1800
      Width           =   3855
   End
   Begin VB.CommandButton cmdComboVB 
      Caption         =   "Add items using AddItem method"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   1080
      Width           =   3855
   End
   Begin VB.ComboBox cmbTest 
      Height          =   315
      Left            =   240
      TabIndex        =   0
      Top             =   360
      Width           =   3375
   End
End
Attribute VB_Name = "frmComboTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'Example for adding items into combo by using Win32 API.
'
'Written by Nir Sofer
'Web site: http://nirsoft.cjb.net

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Const CB_ADDSTRING = &H143
Private Const CB_SETITEMDATA = &H151

Private Sub cmdComboAPI_Click()
    Dim strItemText     As String
    Dim lngIndex        As Long
    Dim dblTimer        As Double
    Dim lngAddIndex     As Long
    
    cmbTest.Clear
    dblTimer = Timer
    'Adding items strings and items data with Win32 API
    For lngIndex = 1 To 5000
        strItemText = "item number " & CStr(lngIndex)
        'Add the new string to the ComboBox.
        lngAddIndex = SendMessage(cmbTest.hWnd, CB_ADDSTRING, 0, ByVal strItemText)
        'Set the item data of the new item.
        SendMessage cmbTest.hWnd, CB_SETITEMDATA, lngAddIndex, ByVal lngIndex
    Next
    MsgBox Format(Timer - dblTimer, "0.000") & " seconds"

End Sub

Private Sub cmdComboVB_Click()
    Dim strItemText     As String
    Dim lngIndex        As Long
    Dim dblTimer        As Double
    
    cmbTest.Clear
    dblTimer = Timer
    'Adding items strings and items data with standard AddItem method.
    For lngIndex = 1 To 5000
        strItemText = "item number " & CStr(lngIndex)
        cmbTest.AddItem strItemText
        cmbTest.ItemData(cmbTest.NewIndex) = lngIndex
    Next
    MsgBox Format(Timer - dblTimer, "0.000") & " seconds"

End Sub
